## rumur 2025.08.31

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.5 FATAL_ERROR)

project(rumur LANGUAGES C CXX)

# This seems to be some magic to get libraries to install correctly.
include(GNUInstallDirs)

set(CMAKE_C_STANDARD 99)
set(CMAKE_C_STANDARD_REQUIRED ON)

set(CMAKE_CXX_STANDARD 11)
set(CMAKE_CXX_STANDARD_REQUIRED ON)

# make asprintf(), mkostemp() prototypes visible
if(CMAKE_SYSTEM_NAME STREQUAL "Linux")
  add_compile_definitions(_GNU_SOURCE)
endif()

set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -W -Wall -Wextra -Wformat=2 \
  -Wwrite-strings -Wmissing-declarations -Wshadow -Wundef")

# enable even more warnings if the compiler supports them
include(CheckCXXCompilerFlag)
CHECK_CXX_COMPILER_FLAG(-Wcast-qual HAS_WARNING_CAST_QUAL)
if(HAS_WARNING_CAST_QUAL)
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wcast-qual")
endif()
CHECK_CXX_COMPILER_FLAG(-Wcast-align HAS_WARNING_CAST_ALIGN)
if(HAS_WARNING_CAST_ALIGN)
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wcast-align")
endif()
CHECK_CXX_COMPILER_FLAG(-Wlogical-op HAS_WARNING_LOGICAL_OP)
if(HAS_WARNING_LOGICAL_OP)
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wlogical-op")
endif()
CHECK_CXX_COMPILER_FLAG(-Wstrict-aliasing=1 HAS_WARNING_STRICT_ALIASING_1)
if(HAS_WARNING_STRICT_ALIASING_1)
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wstrict-aliasing=1")
endif()
CHECK_CXX_COMPILER_FLAG(-Wpointer-arith HAS_WARNING_POINTER_ARITH)
if(HAS_WARNING_POINTER_ARITH)
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wpointer-arith")
endif()
include(CheckCCompilerFlag)
CHECK_C_COMPILER_FLAG(-Wall HAS_C_WARNING_ALL)
if(HAS_C_WARNING_ALL)
  set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Wall")
endif()
CHECK_C_COMPILER_FLAG(-Wextra HAS_C_WARNING_EXTRA)
if(HAS_C_WARNING_EXTRA)
  set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Wextra")
endif()
CHECK_C_COMPILER_FLAG(-Wcast-align=strict HAS_C_WARNING_CAST_ALIGN_STRICT)
if(HAS_C_WARNING_CAST_ALIGN_STRICT)
  set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Wcast-align=strict")
endif()
CHECK_C_COMPILER_FLAG(-Wformat=2 HAS_C_WARNING_FORMAT_2)
if(HAS_C_WARNING_FORMAT_2)
  set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Wformat=2")
endif()
CHECK_C_COMPILER_FLAG(-Wformat-overflow=2 HAS_C_WARNING_FORMAT_OVERFLOW_2)
if(HAS_C_WARNING_FORMAT_OVERFLOW_2)
  set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Wformat-overflow=2")
endif()
CHECK_C_COMPILER_FLAG(-Wlogical-op HAS_C_WARNING_LOGICAL_OP)
if(HAS_C_WARNING_LOGICAL_OP)
  set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Wlogical-op")
endif()
CHECK_C_COMPILER_FLAG(-Wmissing-prototypes HAS_C_WARNING_MISSING_PROTOTYPES)
if(HAS_C_WARNING_MISSING_PROTOTYPES)
  set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Wmissing-prototypes")
endif()
CHECK_C_COMPILER_FLAG(-Wstrict-aliasing=1 HAS_C_WARNING_STRICT_ALIASING_1)
if(HAS_C_WARNING_STRICT_ALIASING_1)
  set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Wstrict-aliasing=1")
endif()
CHECK_C_COMPILER_FLAG(-Wpointer-arith HAS_C_WARNING_POINTER_ARITH)
if(HAS_C_WARNING_POINTER_ARITH)
  set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Wpointer-arith")
endif()
CHECK_C_COMPILER_FLAG(-Wshadow HAS_C_WARNING_SHADOW)
if(HAS_C_WARNING_SHADOW)
  set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Wshadow")
endif()
CHECK_C_COMPILER_FLAG(-Wundef HAS_C_WARNING_UNDEF)
if(HAS_C_WARNING_UNDEF)
  set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Wundef")
endif()
CHECK_C_COMPILER_FLAG(-Wwrite-strings HAS_C_WARNING_WRITE_STRINGS)
if(HAS_C_WARNING_WRITE_STRINGS)
  set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Wwrite-strings")
endif()

# make mkostemp(), pipe2() prototype visible
if(CMAKE_SYSTEM_NAME STREQUAL "Linux")
  add_definitions(-D_GNU_SOURCE)
endif()

# Enable --as-needed, present on GNU ld on Linux, to minimise dependencies.
if(CMAKE_SYSTEM_NAME STREQUAL "Linux")
  set(CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} -Wl,--as-needed")
  set(CMAKE_SHARED_LINKER_FLAGS "${CMAKE_SHARED_LINKER_FLAGS} -Wl,--as-needed")
endif()

if(APPLE)
  list(APPEND CMAKE_INSTALL_RPATH "@executable_path/../${CMAKE_INSTALL_LIBDIR}")
else()
  list(APPEND CMAKE_INSTALL_RPATH "\$ORIGIN/../${CMAKE_INSTALL_LIBDIR}")
endif()

# if we have a new enough CMake to have FindPython3, check for it
if(CMAKE_VERSION VERSION_GREATER 3.11)
  find_package(Python3 REQUIRED COMPONENTS Interpreter)
endif()

add_subdirectory(librumur)
add_subdirectory(murphi-format)
add_subdirectory(murphi2c)
add_subdirectory(murphi2murphi)
add_subdirectory(murphi2smv)
add_subdirectory(murphi2uclid)
add_subdirectory(murphi2xml)
add_subdirectory(rumur)
add_subdirectory(share)
add_subdirectory(tests/murphi-comment-ls)

add_custom_target(check
  COMMAND env
    PATH=${CMAKE_CURRENT_BINARY_DIR}/rumur:${CMAKE_CURRENT_BINARY_DIR}/murphi-format:${CMAKE_CURRENT_BINARY_DIR}/murphi2c:${CMAKE_CURRENT_BINARY_DIR}/murphi2murphi:${CMAKE_CURRENT_BINARY_DIR}/murphi2uclid:${CMAKE_CURRENT_BINARY_DIR}/murphi2xml:${CMAKE_CURRENT_BINARY_DIR}/tests/murphi-comment-ls:$ENV{PATH}
    CPLUS_INCLUDE_PATH=${CMAKE_CURRENT_SOURCE_DIR}/librumur/include:${CMAKE_CURRENT_BINARY_DIR}/librumur
    LIBRARY_PATH=${CMAKE_CURRENT_BINARY_DIR}/librumur
    LD_LIBRARY_PATH=${CMAKE_CURRENT_BINARY_DIR}/librumur
    python3 -m pytest --capture=no --override-ini=cache_dir=${CMAKE_CURRENT_BINARY_DIR} --verbose --verbose ${CMAKE_CURRENT_SOURCE_DIR}/tests/tests.py
  USES_TERMINAL
)
add_dependencies(check
  murphi-format murphi2c murphi2murphi murphi2uclid murphi2xml rumur
)
if(NOT CMAKE_CROSSCOMPILING)
  add_dependencies(check murphi-comment-ls)
endif()

add_custom_target(format
  COMMAND git ls-files -z '**/*.c' '**/*.cc' '**/*.h' |
    xargs -0 -- clang-format -i --style=file
  WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR})

=== librumur/CMakeLists.txt ===
find_package(BISON REQUIRED)
find_package(FLEX REQUIRED)

find_path(GMPXX_INCLUDE NAMES gmpxx.h PATHS ENV CPLUS_INCLUDE_PATH)
if(NOT GMPXX_INCLUDE)
  message(FATAL_ERROR "GMP headers not found")
endif()
find_library(GMP_LIBRARIES NAMES gmp PATHS ENV LIBRARY_PATH)
if(NOT GMP_LIBRARIES)
  message(FATAL_ERROR "libgmp not found")
endif()
find_library(GMPXX_LIBRARIES NAMES gmpxx PATHS ENV LIBRARY_PATH)
if(NOT GMPXX_LIBRARIES)
  message(FATAL_ERROR "libgmpxx not found")
endif()

bison_target(parser
  src/parser.yy
  ${CMAKE_CURRENT_BINARY_DIR}/parser.yy.cc
  COMPILE_FLAGS "--no-lines --warnings=all")
flex_target(lexer
  src/lexer.l
  ${CMAKE_CURRENT_BINARY_DIR}/lexer.l.cc
  COMPILE_FLAGS "--noline")
add_flex_bison_dependency(lexer parser)

# Suppress warnings in generated code.
include(CheckCXXCompilerFlag)
set_source_files_properties(lexer.l.cc PROPERTIES COMPILE_FLAGS "")
CHECK_CXX_COMPILER_FLAG(-Wsign-compare HAS_WARNING_SIGN_COMPARE)
if(HAS_WARNING_SIGN_COMPARE)
  set_source_files_properties(lexer.l.cc PROPERTIES COMPILE_FLAGS "${LEXER_COMPILE_FLAGS} -Wno-sign-compare")
endif()
get_source_file_property(LEXER_COMPILE_FLAGS lexer.l.cc COMPILE_FLAGS)
CHECK_CXX_COMPILER_FLAG(-Wregister HAS_WARNING_REGISTER)
if(HAS_WARNING_REGISTER)
  set_source_files_properties(lexer.l.cc PROPERTIES COMPILE_FLAGS "${LEXER_COMPILE_FLAGS} -Wno-register")
endif()
get_source_file_property(LEXER_COMPILE_FLAGS lexer.l.cc COMPILE_FLAGS)
CHECK_CXX_COMPILER_FLAG(-Wdeprecated-register HAS_WARNING_DEPRECATED_REGISTER)
if(HAS_WARNING_DEPRECATED_REGISTER)
  set_source_files_properties(lexer.l.cc PROPERTIES COMPILE_FLAGS "${LEXER_COMPILE_FLAGS} -Wno-deprecated-register")
endif()

add_custom_command(
  OUTPUT version.c
  COMMAND src/make-version.py ${CMAKE_CURRENT_BINARY_DIR}/version.c
  MAIN_DEPENDENCY src/make-version.py
  DEPENDS always_run
  WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR})

# Dummy output to make sure we always re-evaluate the version step above.
add_custom_command(
  OUTPUT always_run
  COMMAND /usr/bin/env true)

add_library(librumur
  ${CMAKE_CURRENT_BINARY_DIR}/version.c
  src/Boolean.cc
  src/Comment.cc
  src/Decl.cc
  src/except.cc
  src/Expr.cc
  src/Function.cc
  src/indexer.cc
  src/Model.cc
  src/Node.cc
  src/Number.cc
  src/parse.cc
  src/Property.cc
  src/resolve-symbols.cc
  src/Rule.cc
  src/sanitise_rule_names.cc
  src/Stmt.cc
  src/traverse.cc
  src/TypeExpr.cc
  src/validate.cc
  ${FLEX_lexer_OUTPUTS}
  ${BISON_parser_OUTPUTS})

target_include_directories(librumur
  PUBLIC
  $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/include>
  $<INSTALL_INTERFACE:include>
  PRIVATE
  src
  ${CMAKE_CURRENT_BINARY_DIR})
target_include_directories(librumur
  SYSTEM PUBLIC
  ${GMPXX_INCLUDE}
)
target_link_libraries(librumur PUBLIC ${GMPXX_LIBRARIES} ${GMP_LIBRARIES})

# Force the output to librumur.a instead of liblibrumur.a.
set_target_properties(librumur PROPERTIES PREFIX "")

# Clagged boiler plate to install a library.
install(TARGETS librumur EXPORT librumurConfig
  ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR}
  LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}
  RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR})
install(DIRECTORY include/ DESTINATION ${CMAKE_INSTALL_INCLUDEDIR})
install(FILES
  ${CMAKE_CURRENT_BINARY_DIR}/location.hh
  ${CMAKE_CURRENT_BINARY_DIR}/parser.yy.hh
  ${CMAKE_CURRENT_BINARY_DIR}/position.hh
  ${CMAKE_CURRENT_BINARY_DIR}/stack.hh
  DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}/rumur)

install(
  EXPORT librumurConfig
  FILE librumurConfig.cmake
  NAMESPACE rumur::
  DESTINATION ${CMAKE_INSTALL_LIBDIR}/cmake/rumur
)
install(
  FILES rumurConfig.cmake
  DESTINATION ${CMAKE_INSTALL_LIBDIR}/cmake/rumur
)

=== murphi-format/CMakeLists.txt ===
add_custom_command(
  OUTPUT resources_manpage.c
  COMMAND ../misc/xxd.py doc/murphi-format.1 ${CMAKE_CURRENT_BINARY_DIR}/resources_manpage.c
  MAIN_DEPENDENCY doc/murphi-format.1
  DEPENDS ../misc/xxd.py
  WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR})

add_executable(murphi-format
  ${CMAKE_CURRENT_BINARY_DIR}/resources_manpage.c
  ../common/help.c
  src/format.c
  src/lex_free.c
  src/lex_get_token.c
  src/lex_new.c
  src/main.c
)

target_include_directories(murphi-format PRIVATE src)
target_link_libraries(murphi-format PRIVATE librumur)

add_custom_target(man-murphi-format
  ALL
  DEPENDS murphi-format.1.gz)
add_custom_command(
  OUTPUT murphi-format.1.gz
  COMMAND gzip -9 --no-name --to-stdout doc/murphi-format.1 >"${CMAKE_CURRENT_BINARY_DIR}/murphi-format.1.gz"
  MAIN_DEPENDENCY doc/murphi-format.1
  WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR})

install(TARGETS murphi-format
  RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR})
install(FILES
  ${CMAKE_CURRENT_BINARY_DIR}/murphi-format.1.gz
  DESTINATION ${CMAKE_INSTALL_MANDIR}/man1)

=== murphi2c/CMakeLists.txt ===
# Define resources.
add_custom_command(
  OUTPUT resources_manpage.cc
  COMMAND ../misc/xxd.py doc/murphi2c.1 ${CMAKE_CURRENT_BINARY_DIR}/resources_manpage.cc
  MAIN_DEPENDENCY doc/murphi2c.1
  DEPENDS ../misc/xxd.py
  WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR})
add_custom_command(
  OUTPUT resources_c_prefix.cc
  COMMAND ../misc/xxd.py resources/c_prefix.c ${CMAKE_CURRENT_BINARY_DIR}/resources_c_prefix.cc
  MAIN_DEPENDENCY resources/c_prefix.c
  DEPENDS ../misc/xxd.py
  WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR})
add_custom_command(
  OUTPUT resources_h_prefix.cc
  COMMAND ../misc/xxd.py resources/h_prefix.h ${CMAKE_CURRENT_BINARY_DIR}/resources_h_prefix.cc
  MAIN_DEPENDENCY resources/h_prefix.h
  DEPENDS ../misc/xxd.py
  WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR})

add_executable(murphi2c
  ${CMAKE_CURRENT_BINARY_DIR}/resources_c_prefix.cc
  ${CMAKE_CURRENT_BINARY_DIR}/resources_h_prefix.cc
  ${CMAKE_CURRENT_BINARY_DIR}/resources_manpage.cc
  ../common/escape.cc
  ../common/help.c
  src/check.cc
  src/CLikeGenerator.cc
  src/CodeGenerator.cc
  src/compares_complex_values.cc
  src/generate_c.cc
  src/generate_h.cc
  src/main.cc
  src/options.cc)

target_include_directories(murphi2c
  PRIVATE
  src
  ${CMAKE_CURRENT_BINARY_DIR}/../librumur)

target_link_libraries(murphi2c
  PRIVATE
  librumur)

# Compress manpage
add_custom_target(man-murphi2c
  ALL
  DEPENDS murphi2c.1.gz)
add_custom_command(
  OUTPUT murphi2c.1.gz
  COMMAND gzip -9 --no-name --to-stdout doc/murphi2c.1 >"${CMAKE_CURRENT_BINARY_DIR}/murphi2c.1.gz"
  MAIN_DEPENDENCY doc/murphi2c.1
  WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR})

install(TARGETS murphi2c
  RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR})
install(FILES
  ${CMAKE_CURRENT_BINARY_DIR}/murphi2c.1.gz
  DESTINATION ${CMAKE_INSTALL_MANDIR}/man1)

=== murphi2smv/CMakeLists.txt ===
add_custom_command(
  OUTPUT manpage.cc
  COMMAND ../misc/xxd.py doc/murphi2smv.1 ${CMAKE_CURRENT_BINARY_DIR}/manpage.cc
  MAIN_DEPENDENCY doc/murphi2smv.1
  DEPENDS ../misc/xxd.py
  WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}
)

add_executable(murphi2smv
  ${CMAKE_CURRENT_BINARY_DIR}/manpage.cc
  ../common/help.c
  src/codegen.cc
  src/main.cc
  src/pick_numeric_type.cc
)

target_include_directories(murphi2smv PRIVATE
  src
  ${CMAKE_CURRENT_BINARY_DIR}/../librumur
)

target_link_libraries(murphi2smv PRIVATE librumur)

add_custom_target(man-murphi2smv ALL DEPENDS murphi2smv.1.gz)
add_custom_command(
  OUTPUT murphi2smv.1.gz
  COMMAND gzip -9 --no-name --to-stdout doc/murphi2smv.1 >"${CMAKE_CURRENT_BINARY_DIR}/murphi2smv.1.gz"
  MAIN_DEPENDENCY doc/murphi2smv.1
  WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}
)

install(TARGETS murphi2smv
  RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR})
install(FILES
  ${CMAKE_CURRENT_BINARY_DIR}/murphi2smv.1.gz
  DESTINATION ${CMAKE_INSTALL_MANDIR}/man1)

=== murphi2uclid/CMakeLists.txt ===
add_custom_command(
  OUTPUT manpage.cc
  COMMAND ../misc/xxd.py doc/murphi2uclid.1 ${CMAKE_CURRENT_BINARY_DIR}/manpage.cc
  MAIN_DEPENDENCY doc/murphi2uclid.1
  DEPENDS ../misc/xxd.py
  WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR})

add_executable(murphi2uclid
  ${CMAKE_CURRENT_BINARY_DIR}/manpage.cc
  ../common/help.c
  src/check.cc
  src/codegen.cc
  src/main.cc
  src/pick_numeric_type.cc)

target_include_directories(murphi2uclid
  PRIVATE
  src
  ${CMAKE_CURRENT_BINARY_DIR}/../librumur)

target_link_libraries(murphi2uclid
  PRIVATE
  librumur)

add_custom_target(man-murphi2uclid
  ALL
  DEPENDS murphi2uclid.1.gz)
add_custom_command(
  OUTPUT murphi2uclid.1.gz
  COMMAND gzip -9 --no-name --to-stdout doc/murphi2uclid.1 >"${CMAKE_CURRENT_BINARY_DIR}/murphi2uclid.1.gz"
  MAIN_DEPENDENCY doc/murphi2uclid.1
  WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR})

install(TARGETS murphi2uclid
  RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR})
install(FILES
  ${CMAKE_CURRENT_BINARY_DIR}/murphi2uclid.1.gz
  DESTINATION ${CMAKE_INSTALL_MANDIR}/man1)

=== murphi2xml/CMakeLists.txt ===
add_custom_command(
  OUTPUT manpage.cc
  COMMAND ../misc/xxd.py doc/murphi2xml.1 ${CMAKE_CURRENT_BINARY_DIR}/manpage.cc
  MAIN_DEPENDENCY doc/murphi2xml.1
  DEPENDS ../misc/xxd.py
  WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR})

add_executable(murphi2xml
  ${CMAKE_CURRENT_BINARY_DIR}/manpage.cc
  ../common/help.c
  src/main.cc
  src/XMLPrinter.cc)

target_include_directories(murphi2xml
  PRIVATE
  src
  ${CMAKE_CURRENT_BINARY_DIR}/../librumur)

target_link_libraries(murphi2xml
  PRIVATE
  librumur)

# Compress manpages
add_custom_target(man-murphi2xml
  ALL
  DEPENDS murphi2xml.1.gz)
add_custom_command(
  OUTPUT murphi2xml.1.gz
  COMMAND gzip -9 --no-name --to-stdout doc/murphi2xml.1 >"${CMAKE_CURRENT_BINARY_DIR}/murphi2xml.1.gz"
  MAIN_DEPENDENCY doc/murphi2xml.1
  WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR})

install(TARGETS murphi2xml
  RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR})
install(FILES
  ${CMAKE_CURRENT_BINARY_DIR}/murphi2xml.1.gz
  DESTINATION ${CMAKE_INSTALL_MANDIR}/man1)

=== rumur/CMakeLists.txt ===
# Define resources.
add_custom_command(
  OUTPUT resources_manpage.cc
  COMMAND ../misc/xxd.py doc/rumur.1 ${CMAKE_CURRENT_BINARY_DIR}/resources_manpage.cc
  MAIN_DEPENDENCY doc/rumur.1
  DEPENDS ../misc/xxd.py
  WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR})
add_custom_command(
  OUTPUT resources_includes.cc
  COMMAND ../misc/xxd.py resources/includes.c ${CMAKE_CURRENT_BINARY_DIR}/resources_includes.cc
  MAIN_DEPENDENCY resources/includes.c
  DEPENDS ../misc/xxd.py
  WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR})
add_custom_command(
  OUTPUT resources_header.cc
  COMMAND ../misc/xxd.py resources/header.c ${CMAKE_CURRENT_BINARY_DIR}/resources_header.cc
  MAIN_DEPENDENCY resources/header.c
  DEPENDS ../misc/xxd.py
  WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR})

add_executable(rumur
  ${CMAKE_CURRENT_BINARY_DIR}/resources_includes.cc
  ${CMAKE_CURRENT_BINARY_DIR}/resources_header.cc
  ${CMAKE_CURRENT_BINARY_DIR}/resources_manpage.cc
  ../common/escape.cc
  ../common/help.c
  src/assume-statements-count.cc
  src/generate-allocations.cc
  src/generate-cover-array.cc
  src/generate-decl.cc
  src/generate-expr.cc
  src/generate-function.cc
  src/generate-model.cc
  src/generate-print.cc
  src/generate-property.cc
  src/generate-quantifier.cc
  src/generate-stmt.cc
  src/has-start-state.cc
  src/log.cc
  src/main.cc
  src/max-simple-width.cc
  src/optimise-field-ordering.cc
  src/options.cc
  src/output.cc
  src/prints-scalarsets.cc
  src/process.cc
  src/smt/define-enum-members.cc
  src/smt/define-records.cc
  src/smt/logic.cc
  src/smt/simplify.cc
  src/smt/solver.cc
  src/smt/translate.cc
  src/smt/typeexpr-to-smt.cc
  src/symmetry-reduction.cc
  src/utils.cc
  src/ValueType.cc)

target_include_directories(rumur
  PRIVATE
  src
  # FIXME: This is a hack to include generated headers from the library. We
  # really want to be able to stage these somewhere and talk about them here
  # as if they were just a regular, static exported header.
  ${CMAKE_CURRENT_BINARY_DIR}/../librumur)

target_link_libraries(rumur
  PRIVATE
  librumur)

# Compress manpages
add_custom_target(man-rumur
  ALL
  DEPENDS rumur.1.gz rumur-run.1.gz)
add_custom_command(
  OUTPUT rumur.1.gz
  COMMAND gzip -9 --no-name --to-stdout doc/rumur.1 >"${CMAKE_CURRENT_BINARY_DIR}/rumur.1.gz"
  MAIN_DEPENDENCY doc/rumur.1
  WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR})
add_custom_command(
  OUTPUT rumur-run.1.gz
  COMMAND gzip -9 --no-name --to-stdout doc/rumur-run.1 >"${CMAKE_CURRENT_BINARY_DIR}/rumur-run.1.gz"
  MAIN_DEPENDENCY doc/rumur-run.1
  WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR})

install(TARGETS rumur
  RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR})
install(PROGRAMS
  ${CMAKE_CURRENT_SOURCE_DIR}/src/rumur-run
  DESTINATION ${CMAKE_INSTALL_BINDIR})
install(FILES
  ${CMAKE_CURRENT_BINARY_DIR}/rumur.1.gz
  ${CMAKE_CURRENT_BINARY_DIR}/rumur-run.1.gz
  DESTINATION ${CMAKE_INSTALL_MANDIR}/man1)

=== share/CMakeLists.txt ===
install(
  FILES
    _list
    _set
    README.rst
  DESTINATION ${CMAKE_INSTALL_DATAROOTDIR}/rumur/lib
)
install(DIRECTORY v2025.01.04
  DESTINATION ${CMAKE_INSTALL_DATAROOTDIR}/rumur/lib
)
install(DIRECTORY v2025.01.05
  DESTINATION ${CMAKE_INSTALL_DATAROOTDIR}/rumur/lib
)
install(DIRECTORY v2025.02.02
  DESTINATION ${CMAKE_INSTALL_DATAROOTDIR}/rumur/lib
)
install(DIRECTORY v2025.08.31
  DESTINATION ${CMAKE_INSTALL_DATAROOTDIR}/rumur/lib
)

=== tests/murphi-comment-ls/CMakeLists.txt ===
# this is only usable for testing if we are targeting the host machine
if(NOT CMAKE_CROSSCOMPILING)
  add_executable(murphi-comment-ls main.cc)
  target_include_directories(murphi-comment-ls PRIVATE
    ${CMAKE_CURRENT_BINARY_DIR}/../../librumur)
  target_link_libraries(murphi-comment-ls PRIVATE librumur)
endif()

=== debian/changelog ===
rumur (2025.08.31-1) unstable; urgency=medium

  * New upstream release.
  * Update Standards-Version from 4.7.0 to 4.7.2.
  * Update CMake build requirement from 3.2 to 3.5. Closes: #1113481.

 -- Matthew Fernandez <matthew.fernandez@gmail.com>  Sun, 31 Aug 2025 20:59:02 -0700

=== debian/control ===
Source: rumur
Section: devel
Priority: optional
Maintainer: Matthew Fernandez <matthew.fernandez@gmail.com>
Build-Depends: debhelper-compat (= 13),
 bison,
 cmake,
 flex,
 libfl-dev,
 libgmp-dev,
 libxml2-utils,
 python3,
 python3-pytest,
 strace,
 z3
Standards-Version: 4.7.2
Homepage: https://github.com/Smattr/rumur
Vcs-Git: https://github.com/Smattr/rumur.git -b packaging/debian
Vcs-Browser: https://github.com/Smattr/rumur/tree/packaging/debian
Rules-Requires-Root: no

Package: rumur
Architecture: any
Depends: python3, ${shlibs:Depends}, ${misc:Depends}
Suggests: z3
Description: model checker for the Murphi language
 Rumur is a model checker for use in the formal verification of finite state
 machines specified in the Murphi modelling language. It is based on a previous
 tool, CMurphi, and attempts to provide an approximate drop-in replacement for
 CMurphi.
 .
 Rumur works by reading an input file describing a collection of state variables
 and transition rules, from which it generates a C program to verify safety and
 security properties of this state machine. The generated verifier works by
 exhaustively exploring the state space, checking for violation of invariants or
 deadlocks.
 .
 In comparison to CMurphi, Rumur generates a verifier that runs significantly
 faster and uses less memory on large input problems. Rumur comes with an
 optional wrapper script, rumur-run, that streamlines the process of generating
 a verifier, compiling it, and then running it. This wrapper requires Python.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

# Enable all hardening compiler flags (-D_FORTIFY_SOURCE=2 -Wl,-z,now ...)
export DEB_BUILD_MAINT_OPTIONS=hardening=+all

# for DEB_VERSION
include /usr/share/dpkg/pkg-info.mk

# Override native version number with Debianized version number
export RUMUR_VERSION=v${DEB_VERSION}

%:
	dh $@
